#include <stdio.h>
#include <string>
#include "big.cpp"

using namespace std;

// Sprawdza czy string zawiera same cyfry
int digits(char *p)
{
        int i;

        for (i = 0; p[i] != 0; i++)
                if ((p[i] < '0') || (p[i] > '9'))
                        return 0;
        return 1;
}

// Potega
Vbig pow(Vbig a, Vbig b)
{
        Vbig w = 1;
        Vbig i;

        for (i = 1; i <= b; i = i + 1)
                w = w * a;
        return w;
}

// 1 jesli nawiasy redukowalne, 0 jesli nieredukowalne
int braketstate(char *p)
{
        int i;
        int level = 0;
        int cool = 0;

        for (i = 0; p[i] != 0; i++) {
                if (p[i] == '(')
                        level++;
                if (p[i] == ')')
                        level--;
                if ((i == 0) && (p[i] == '('))
                        cool = 1;
                if ((cool == 1) && (level == 0) && (p[i + 1] != 0))
                        cool = 0;
        }
        return cool;
}

// Podaje pozycje plusa lub minusa na zerowym poziome nawiasow
int pluss(char *s)
{
        int i;
        int level = 0;

        for (i = 0; s[i] != 0; i++) {
                if (s[i] == '(')
                        level++;
                if (s[i] == ')')
                        level--;
                if (((s[i] == '+') || (s[i] == '-')) && (level == 0))
                        return i;
        }
        return -1;
}

// Podaje pozycje asterixa lub slasha na zerowym poziomie nawiasow
int aster(char *s)
{
        int i;
        int level = 0;

        for (i = 0; s[i] != 0; i++) {
                if (s[i] == '(')
                        level++;
                if (s[i] == ')')
                        level--;
                if (((s[i] == '*') || (s[i] == '/') || (s[i] == '%')) && (level == 0))
                        return i;
        }
        return -1;
}

// Podaje pozycje daszka
int dasz(char *s)
{
        int i;
        int level = 0;

        for (i = 0; s[i] != 0; i++) {
                if (s[i] == '(')
                        level++;
                if (s[i] == ')')
                        level--;
                if ((s[i] == '^') && (level == 0))
                        return i;
        }
        return -1;
}

// Oblicza wyrazenie 
Vbig wyrazenie(char *wyr)
{
        Vbig a;
        Vbig z;
        int i, j;
        char *wew;
        char *left;
        char *right;

// Ewentualna redukcja nawiasow
        if (braketstate(wyr) == 1) {
                wew = (char *) malloc(strlen(wyr) - 1);
                for (i = 1; i < int(strlen(wyr)) - 1; i++)
                        wew[i - 1] = wyr[i];
                wew[i - 1] = 0;
        } else {
                wew = (char *) malloc(strlen(wyr) + 2);
                for (i = 0; i <= int(strlen(wyr)); i++)
                        wew[i] = wyr[i];
        }
        if (braketstate(wew) == 1)
                return wyrazenie(wew);
// Jesli same liczby ->
        if (digits(wew) == 1) {
                a.ch(wew);
                free(wew);
                return a;
        } else {
// Jesli wystepuje plus lub minus 
                i = pluss(wew);
                if (i != -1) {
                        left = (char *) malloc(i + 1);
                        right = (char *) malloc(strlen(wew) - i + 1);
                        for (j = 0; j < i; j++)
                                left[j] = wew[j];
                        left[j] = 0;
                        for (j = i + 1; j <= int(strlen(wew)); j++)
                                right[j - i - 1] = wew[j];
                        right[j - i] = 0;
                        if (wew[i] == '+')
                                a = wyrazenie(left) + wyrazenie(right);
                        if (wew[i] == '-')
                                a = wyrazenie(left) - wyrazenie(right);
                        free(left);
                        free(right);
                        free(wew);
                        return a;
                }
// Jesli wystepuje asterix lub slash   
                i = aster(wew);
                if (i != -1) {
                        Vbig r, l;

                        left = (char *) malloc(i + 1);
                        right = (char *) malloc(strlen(wew) - i + 1);
                        for (j = 0; j < i; j++)
                                left[j] = wew[j];
                        left[j] = 0;
                        for (j = i + 1; j <= int(strlen(wew)); j++)
                                right[j - i - 1] = wew[j];
                        right[j - i] = 0;
                        l = wyrazenie(left);
                        r = wyrazenie(right);
                        if (wew[i] == '*')
                                a = l * r;
                        if (wew[i] == '/')
                                if (r != z)
                                        a = l / r;
                                else {
                                        a = 0x0FFFFFFF;
                                        printf("ALARM !!! Dzielenie przez 0 !!! \b\n");
                                }
                        if (wew[i] == '%')
                                if (r != z)
                                        a = l % r;
                                else {
                                        a = 0x0FFFFFFF;
                                        printf("ALARM !!! Dzielenie przez 0 !!! \b\n");
                                }
                        free(left);
                        free(right);
                        free(wew);
                        return a;
                }
                i = dasz(wew);
                if (i != -1) {
                        Vbig r, l;

                        left = (char *) malloc(i + 1);
                        right = (char *) malloc(strlen(wew) - i + 1);
                        for (j = 0; j < i; j++)
                                left[j] = wew[j];
                        left[j] = 0;
                        for (j = i + 1; j <= int(strlen(wew)); j++)
                                right[j - i - 1] = wew[j];
                        right[j - i] = 0;
                        l = wyrazenie(left);
                        r = wyrazenie(right);
                        a = pow(l, r);
                        free(left);
                        free(right);
                        free(wew);
                        return a;
                }
        }
// Tu program nigdy nie dochodzi 
   return a;
}

// Sprawdza poprawnosc wyrazenia (ilosc nawiasow)
int parser(char *p)
{
        int i, a, b;

        a = 0;
        b = 0;
        for (i = 0; p[i] != 0; i++)
                if (p[i] == '(')
                        a++;
        for (i = 0; p[i] != 0; i++)
                if (p[i] == ')')
                        b++;
        if (a != b)
                return 1;
        return 0;
}

int main()
{
        char wyr[512];
        char wej[512];
        Vbig a;
        int i, j;

        fgets(wej, 512, stdin);
        i = 0;
        j = 0;
        while (i < 100) {
                if (((wej[i] >= '0') && (wej[i] <= '9')) ||
                    (wej[i] == '+') ||
                    (wej[i] == '-') ||
                    (wej[i] == '*') ||
                    (wej[i] == '/') ||
                    (wej[i] == '%') ||
                    (wej[i] == '^') || (wej[i] == '(') || (wej[i] == 0) || (wej[i] == ')')) {
                        wyr[j] = wej[i];
                        j++;
                }
                i++;
        }
        if (parser(wyr) != 0) {
                printf("W wyrazeniu jest blad !!!\n");
                return 1;
        } else {
                a = wyrazenie(wyr);
                string s;

                s = a.str();
                printf("%s\n", s.c_str());
        }

        return 0;
}
